/***************************************************************************
*   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
*   rvinyard@cs.nmsu.edu                                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Lesser General Public License as        *
*   published by the Free Software Foundation version 2.1.                *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Lesser General Public      *
*   License along with this library; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
***************************************************************************/
#ifndef BITFACTORY_H
#define BITFACTORY_H

#include <bit/fieldbase.h>
#include <bit/fieldtype.h>
#include <bit/field.h>
#include <bit/fieldvector.h>
#include <bit/record.h>
#include <bit/recordvector.h>

namespace bit {

  extern std::vector<std::string> xml_file_load_path;

  void initialize_xml_file_load_path();

  RecordBase::pointer xml_load_file(const std::string& filename);
  RecordBase::pointer xml_load_memory(const std::string& string);
  RecordBase::pointer xml_load_memory_raw(const unsigned char *contents, size_t bytes_count);
  RecordBase::pointer xml_load_stream(std::istream &in);

  RecordBase::pointer xml_read_record(xmlpp::Element& xml_element, int& last_position, size_t length_units=BITS, size_t offset_units=BITS);

  Field::pointer xml_read_field(xmlpp::Element& xml_element, int& last_position, size_t length_units=BITS, size_t offset_units=BITS);

  FieldType xml_read_type(xmlpp::Element& xml_element);

  void xml_read_skip(xmlpp::Element& xml_element, int& last_position, size_t length_units=BITS, size_t offset_units=BITS);

  size_t get_units(std::string s);

  std::string get_xml_file_as_string(const std::string& filename);
}

#endif
